'From Cuis 2.0 of 24 February 2010 [latest update: #440] on 2 March 2010 at 10:36:15 am'!

!SystemDictionary methodsFor: 'Closure measurements' stamp: 'jmv 3/2/2010 09:22'!
browseMethodsWithEmptyClosures
	"
	Smalltalk browseMethodsWithEmptyClosures
	"
	| emptyClosurePattern |
	emptyClosurePattern _ ByteArray readHexFrom: '8F000002737D'.
	self
		browseAllSelect: [ :m | | s |
			s _ InstructionStream on: m.
			s scanFor: [ :bytecode |
				bytecode = emptyClosurePattern first and: [
					(1 to: emptyClosurePattern size) allSatisfy: [ :i |
						(s method at: s pc + i - 1) = (emptyClosurePattern at: i) ]]]]
		name:  'Methods with empty closures'
		autoSelect: '[]'! !


!UndefinedObject methodsFor: 'evaluating' stamp: 'jmv 3/2/2010 09:28'!
valueWithPossibleArgs: anArray
	"To provide polymorphism with blocks. Allows nil to be used instead of an empty closure."! !


!UndefinedObject reorganize!
('evaluating' valueWithPossibleArgs:)
('copying' clone deepCopy shallowCopy veryDeepCopyWith:)
('printing' printOn: storeOn:)
('testing' haltIfNil ifNil: ifNil:ifNotNil: ifNotNil: ifNotNil:ifNil: isEmptyOrNil isLiteral isNil notNil)
('dependents access' addDependent: suspend)
('class hierarchy' addSubclass: literalScannedAs:notifying: removeSubclass: subclass:instanceVariableNames:classVariableNames:poolDictionaries:category: subclassDefinerClass subclasses subclassesDo: subclassesDoGently: typeOfClass)
('3ds parser support' from3DS:)
('bottom context' canHandleSignal: handleSignal:)
('as yet unclassified' environment)
!

